////////////////////////////////////////////////////////////////////
//
// MCB ScalpWiz 3.2
// 
//
//
#property copyright "Copyright  2015, MCB Shenannegans."
#property link      "marchaxcpp@gmail.com"

extern int    MaxSpread           = 30;
extern int    MaxOpenOrders       = 4;
extern int    PercentRisk         = 2;
extern int    StopPriceBuffer     = 30;
extern int    TakeProfit          = 1000;
extern int    TrailingStop        = 15;
extern int    OpenStopLoss        = 200;
extern int    Slippage            = 3;
extern int    ExpirationInMinutes = 10;
extern bool   UseStops            = true;
extern string comment             = "MCB.SW.3.2";
input  color  TextColor           = clrBlack;


extern double Level1Pips          = 300.0;
extern double Level2Pips          = 400.0;
extern double Level3Pips          = 500.0;
extern double Level4Pips          = 600.0;

extern int StengthLevel1Multiplier = 1;
extern int StengthLevel2Multiplier = 2;
extern int StengthLevel3Multiplier = 3;
extern int StengthLevel4Multiplier = 4;
extern string msg = "M1 Chart Only";

int MagicNumber =         91824446;

double preAsk = 0;
double preBid = 0;

double RSI = 0;
int StopLevel = 0;
datetime ExpDate;

bool Order1Open = false;
bool Order2Open = false;
bool Order3Open = false;
bool Order4Open = false;

string CurrDate = "";

//////////////////////////////////////////////////////////////////////
//
//
//
int TotalChartOrders()
{
   int iRetVal = 0;
   int iTtl    = OrdersTotal();
   for(int i = 0; i < iTtl; i++)
   {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
      {
         if(OrderSymbol() == Symbol())
            iRetVal++;
      }
   }
   return iRetVal;
   
}

//////////////////////////////////////////////////////////////////////
//
// gets lot size for percentage of account you want to risk
//
double PercentPurchase(double price, double balance, int istrength)
{
   double dRetVal;
   double dLotPrice = price * 1000;
   double percentage = balance * ((istrength * PercentRisk) * 0.01);
   percentage = NormalizeDouble(percentage, 2);
   dRetVal = NormalizeDouble((percentage / dLotPrice),2);
   if(dRetVal < .01)
      dRetVal = .01;
   
   return dRetVal;
}

///////////////////////////////////////////////////////////////////////
//
// Opens buy/buy stop and multiplies lot size based on signal strength
//
bool OpenSingleBuy(int strength,string cmt) 
{

    int ticket = -1;

    RefreshRates();
    double Price        = NormalizeDouble(Ask,Digits());
    if(UseStops) Price  = NormalizeDouble(Ask + StopPriceBuffer * Point,Digits());
    double BuyTP        = NormalizeDouble((Price + TakeProfit * Point),Digits());
    double BuySL        = NormalizeDouble((Price - OpenStopLoss * Point),Digits());
    double dLots        = PercentPurchase(Ask,AccountBalance(),strength);
    
    if(UseStops)
      ticket = OrderSend( Symbol(), OP_BUYSTOP, dLots, Price, Slippage, BuySL, 0, cmt, MagicNumber, 0, Lime); // StringToTime(TimeToString(ExpDate,TIME_DATE) + " " + TimeToString(ExpDate,TIME_MINUTES)), Lime);
    else
      ticket = OrderSend( Symbol(), OP_BUY, dLots, Price, Slippage, BuySL, BuyTP, cmt, MagicNumber, 0, Lime);
    
    if(ticket < 0) 
    {
      Print ("Failed to OpenSingleBuy, error # ", Error(GetLastError()));
      Print("Buy Trade params: Symbol: " + Symbol() +
            " Lot Size: "   + dLots +
            " Ask: "        + Ask +
            " Bid: "        + Bid +
            " StopAsk: "    + Price +
            " Slip: "       + Slippage +
            " Stoploss: "   + BuySL + 
            " TakeProfit: " + BuyTP +
            " ExpDate: "    + ExpDate );
      return (false);
    } 
    else 
    {
      PlaySound("alert2.wav");
      Print ("Successfully placed order with OpenSingleBuy");
      return (true);
    }
   return (false);
}

///////////////////////////////////////////////////////////////////////
//
// Opens sell/sell stop and multiplies lot size based on signal strength
//
bool OpenSingleSell(int strength,string cmt) 
{

    int ticket = -1;

    RefreshRates();
    double BidStopPrice = NormalizeDouble(Bid - StopPriceBuffer * Point,Digits());
    double SellSL       = NormalizeDouble(Bid + OpenStopLoss    * Point,Digits());
    double SellTP       = NormalizeDouble(Bid - TakeProfit      * Point,Digits());

    double dLots = PercentPurchase(Bid,AccountBalance(),strength);
    if(UseStops)
 
      ticket = OrderSend( Symbol(), 
                          OP_SELLSTOP, dLots, BidStopPrice,Slippage, SellSL, 0, cmt, MagicNumber, 0, Lime); //StringToTime(TimeToString(ExpDate,TIME_DATE) + " " + TimeToString(ExpDate,TIME_MINUTES)), Lime);
    else
      ticket = OrderSend( Symbol(), OP_SELL, dLots, Bid, Slippage, SellSL, SellTP, cmt, MagicNumber, 0, Lime);
    
    if (ticket <0) {
      Print ("Failed to OpenSingleSell, error # ", Error(GetLastError()));
      Print("Sell Trade params: Symbol: " + Symbol() +
            " Lot Size: "   + dLots +
            " Ask: "        + Ask +
            " Bid: "        + Bid +
            " StopBid: "    + BidStopPrice +
            " Slip: "       + Slippage +
            " Stoploss: "   + SellSL + 
            " TakeProfit: " + SellTP +
            " ExpDate: "    + ExpDate );
      return (false);
    } else {
      PlaySound("alert2.wav");
      Print ("Successfully placed order with OpenSingleSell");
      return (true);
    }
   return (false);
}

///////////////////////////////////////////////////////////////////////////////
//
//
int init() {

   ObjectCreate("lblTop", OBJ_LABEL, 0, 0, 0, 0, 0);
   ObjectCreate("lblBottom", OBJ_LABEL, 0, 0, 0, 0, 0);
    
   ObjectCreate(0,"CloseButton",OBJ_BUTTON,0,0,0);
   ObjectSetInteger(0,"CloseButton",OBJPROP_XDISTANCE,15);
   ObjectSetInteger(0,"CloseButton",OBJPROP_YDISTANCE,15);
   ObjectSetInteger(0,"CloseButton",OBJPROP_XSIZE,250);
   ObjectSetInteger(0,"CloseButton",OBJPROP_YSIZE,150);
   //ObjectSetString(0,"CloseButton",OBJPROP_TEXT,"Close Orders");
   ObjectSetInteger(0,"CloseButton",OBJPROP_COLOR,White);
   ObjectSetInteger(0,"CloseButton",OBJPROP_BGCOLOR,White);
   ObjectSetInteger(0,"CloseButton",OBJPROP_BORDER_COLOR,White);
   ObjectSetInteger(0,"CloseButton",OBJPROP_BORDER_TYPE,BORDER_FLAT);
   ObjectSetInteger(0,"CloseButton",OBJPROP_HIDDEN,true);
   ObjectSetInteger(0,"CloseButton",OBJPROP_STATE,false);
   ObjectSetInteger(0,"CloseButton",OBJPROP_BACK,true); 
   return (0);
}

///////////////////////////////////////////////////////////////////////////////
//
//
int deinit() 
{
   ObjectDelete("lblTop");
   ObjectDelete("lblBottom");
   return (0);
}

///////////////////////////////////////////////////////////////////////////////
//
//
void OnTick()
{
   int vspread = MarketInfo(Symbol(),MODE_SPREAD);
   if(vspread >= MaxSpread)
   {
      Comment ("**Spread too high (" + vspread +") - EA is not running");
      return;
   }
   
   
   double balance      = AccountBalance();
   double BuyTP        = NormalizeDouble((Ask + TakeProfit * Point),Digits());
   double BuySL        = NormalizeDouble((Ask - OpenStopLoss * Point),Digits());
   double SellSL       = NormalizeDouble(Bid + OpenStopLoss    * Point,Digits());
   double SellTP       = NormalizeDouble(Bid - TakeProfit      * Point,Digits());
   

   double _bid         = NormalizeDouble(MarketInfo(Symbol(), MODE_BID), Digits); //define a lower price 
   double _ask         = NormalizeDouble(MarketInfo(Symbol(), MODE_ASK), Digits); //define an upper price
   double _point       = MarketInfo(Symbol(), MODE_POINT);
   double open         = NormalizeDouble(iOpen(Symbol(),Period(),0),Digits);
   double low          = NormalizeDouble(iLow(Symbol(), Period(), 0), Digits);
   double high         = NormalizeDouble(iHigh(Symbol(), Period(), 0), Digits);
   double bar1size     = NormalizeDouble(((high-low)/_point),0);
   double d1MCCI       = iCCI(Symbol(),PERIOD_M1,14,PRICE_TYPICAL,0);
   string sDirection = "";
   if(d1MCCI < 0)
      sDirection = "Falling ";
   if(d1MCCI > 0)
      sDirection = "Rising ";

      
   
   
   ObjectSetText("lblBottom", sDirection + bar1size + " CCI: " + d1MCCI, 10, "Arial", Black);
   
   ExpDate = TimeCurrent();
   ExpDate += TimeMinute(ExpDate) + ExpirationInMinutes * 60;
   StopLevel = MarketInfo(Symbol(),MODE_STOPLEVEL);
   Comment(TimeToString(ExpDate,TIME_DATE) + " " + TimeToString(ExpDate,TIME_MINUTES)+ " Spread: " + vspread);

   ObjectSet("lblTop", OBJPROP_COLOR, Black);
   ObjectSet("lblTop", OBJPROP_CORNER, 2);
   ObjectSet("lblTop", OBJPROP_XDISTANCE, 3);
   ObjectSet("lblTop", OBJPROP_YDISTANCE, 3);
   ObjectSet("lblBottom", OBJPROP_COLOR, Black);
   ObjectSet("lblBottom", OBJPROP_CORNER, 2);
   ObjectSet("lblBottom", OBJPROP_XDISTANCE, 3);
   ObjectSet("lblBottom", OBJPROP_YDISTANCE, 23);
   
   UpdateStats();
   
   int total = OrdersTotal();
   int i = 0;
   
   if(total > 0)
   {
      if(preAsk == 0) preAsk = Ask;
      if(preBid == 0) preBid = Bid;
   }
   if(CurrDate != TimeToString(ExpDate,TIME_DATE))
   {
      CurrDate = TimeToString(ExpDate,TIME_DATE);
      Print("Processing ticks for " + CurrDate);
   }
   
   for(i = 0; i < total; i++)
   {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
      {
         Order1Open = false;
         Order2Open = false;
         Order3Open = false;
         Order4Open = false;
         if((OrderSymbol() == Symbol()) && (OrderMagicNumber() == MagicNumber))
         {
            if(StringFind(OrderComment(), "s1") || StringFind(OrderComment(), "b1"))
               Order1Open = true;            
            if(StringFind(OrderComment(), "s2") || StringFind(OrderComment(), "b2"))
               Order2Open = true;
            if(StringFind(OrderComment(), "s3") || StringFind(OrderComment(), "b3"))
               Order3Open = true;      
            if(StringFind(OrderComment(), "s4") || StringFind(OrderComment(), "b4"))
               Order4Open = true;
         }
         if((OrderType() == OP_BUY || OrderType() == OP_SELL) && (OrderSymbol() == Symbol()) && (OrderMagicNumber() == MagicNumber))
         {  
             
            if(Bid-OrderOpenPrice() > Point*TrailingStop)
            {
               if(OrderStopLoss() < Bid - Point * TrailingStop )
               {
                  RefreshRates();
                  if(!OrderModify(OrderTicket(),
                              OrderOpenPrice(),
                              NormalizeDouble(Bid - (Point*TrailingStop),Digits), //BuySL,
                              0,//NormalizeDouble(Ask + (TakeProfit * Point),Digits),//BuyTP,
                              0,//OrderExpiration(),
                              Green))
                  {

                     Print ("Failed to modify, error # ", Error(GetLastError()));
                     Print("Modify Trade params: Symbol: " + Symbol() +
                        " OrderType: SELL "  + OrderType() + 
                        " Open: "       + OrderOpenPrice() +
                        " Ask: "        + Ask +
                        " Bid: "        + Bid +
                        " SL: "         + NormalizeDouble(Bid - (Point*TrailingStop),Digits) +
                        " TP: "         + NormalizeDouble(Ask + (TakeProfit * Point),Digits) +
                        " ChaseAsk: "   + (Ask + (StopLevel * Point)) + 
                        " ExpDate : "   + OrderExpiration());

                  }
               }
            }
            if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
            {
               if(((OrderStopLoss()>(Ask+Point*TrailingStop))) || (OrderStopLoss()==0))
               {
                   //--- modify order and exit
                   //Print("Order #",OrderTicket()," profit: ", OrderProfit());
                  // SELLModify
                  RefreshRates();
                  if(!OrderModify(OrderTicket(), 
                              OrderOpenPrice(), 
                              NormalizeDouble(Ask + (Point * TrailingStop),Digits),//SellSL, 
                              0,//NormalizeDouble(Bid - (TakeProfit * Point),Digits),//SellTP, 
                              0,//OrderExpiration(), 
                              Red))
                  {

                     Print ("Failed to modify, error # ", Error(GetLastError()));
                     Print("Modify Trade params: Symbol: " + Symbol() +
                        " OrderType: BUY "  + OrderType() + 
                        " Open: "       + OrderOpenPrice() +
                        " Ask: "        + Ask +
                        " Bid: "        + Bid +
                        " SL: "         + (Ask + (Point * TrailingStop)) +
                        " TP: "         + (Bid - (TakeProfit* Point)) +
                        " ChaseAsk: "   + (Ask + StopLevel * Point) + 
                        " ExpDate : "   + OrderExpiration());;

                  }

               }
            }
         }
         int iOrderType = OrderType();
         // chase price with open stops
         if((OrderType() == OP_BUYSTOP || OrderType() == OP_SELLSTOP) && (OrderSymbol() == Symbol()) && (OrderMagicNumber() == MagicNumber))
         {
            StopLevel = MarketInfo(Symbol(),MODE_STOPLEVEL) + StopPriceBuffer;
            if(OrderType()==OP_BUYSTOP && (Ask <= preAsk))
            {
               double dNewBuyStopPrice = Ask + ((StopLevel*2) * Point);
               preAsk = Ask;
               RefreshRates();
               if(!OrderModify(OrderTicket(), 
                           Ask + StopLevel * Point, 
                           Ask - OpenStopLoss    * Point,//NormalizeDouble((Bid + TakeProfit      * Point),Digits()),
                           0,//NormalizeDouble((Ask - OpenStopLoss    * Point),Digits()), 
                           0,//OrderExpiration(),
                           Red))
               {
                  Print ("Failed to modify BUY_STOP, error # ", Error(GetLastError()));
                  Print("Modify Trade params: Symbol: " + Symbol() +
                        " OrderType: BUY_STOP "  + OrderType() + 
                        " Open: "       + OrderOpenPrice() +
                        " Ask: "        + Ask +
                        " Bid: "        + Bid +
                        " SL: "         + NormalizeDouble((Ask + StopPriceBuffer * Point),Digits()) +
                        " TP: "         + NormalizeDouble((Bid + TakeProfit      * Point),Digits()) +
                        " ChaseAsk: "   + NormalizeDouble((Ask - OpenStopLoss    * Point),Digits()) + 
                        " ExpDate : "   + OrderExpiration());
               }

            }
            if(OrderType()==OP_SELLSTOP && Bid >= preBid)
            {
               
               double dNewSellStopPrice = Bid-((StopLevel*2) *Point);
               preBid = Bid; 
               RefreshRates();
               if(!OrderModify(OrderTicket(), 
                           Bid - StopLevel * Point,
                           Bid + OpenStopLoss      * Point,//NormalizeDouble(Ask + OpenStopLoss    * Point,Digits()),
                           0,//NormalizeDouble(Bid - TakeProfit      * Point,Digits()),
                           0,//OrderExpiration(),
                           Green))
               {
                  Print ("Failed to modify SELL_STOP, error # ", Error(GetLastError()));
                  Print("Modify Trade params: Symbol: " + Symbol() +
                        " OrderType: SELL_STOP "  + OrderType() + 
                        " Open: "       + OrderOpenPrice() +
                        " Ask: "        + Ask +
                        " Bid: "        + Bid +
                        " SL: "         + NormalizeDouble(Bid - StopPriceBuffer * Point,Digits()) +
                        " TP: "         + NormalizeDouble(Bid - TakeProfit      * Point,Digits()) +
                        " ChaseAsk: "   + NormalizeDouble(Bid - StopPriceBuffer * Point,Digits()) +
                        " ExpDate: "    + OrderExpiration());
               }
            }
         }
      } 
   }
   
   int ind_counted_0 = IndicatorCounted();
   if (Period() != PERIOD_M1) 
      int x = 1;
      //ObjectSetText("lblBottom", "Attach to M1 chart", 12, "Arial", Black);
   else 
   {
      bool cciGTZero   = d1MCCI > 0;
      bool barGTLevel1 = bar1size > Level1Pips;
      bool NotMaxOrder = MaxOpenOrders > TotalChartOrders();
      
      
      if((_bid > open) && 
         (bar1size > Level4Pips) && 
         (MaxOpenOrders > TotalChartOrders() &&
         !Order4Open))
      {
         //OpenSingleBuy(4,"b4");
         if(UseStops)
            OpenSingleSell(4,"s1");
         return;
      }
      if((_bid > open) && 
         (bar1size > Level3Pips) && 
         (MaxOpenOrders > TotalChartOrders() &&
         !Order3Open))
      {
         //OpenSingleBuy(3,"b3");
         if(UseStops)
            OpenSingleSell(3,"s1");
         return;
      }
      if((_bid > open) && 
         (bar1size > Level2Pips) && 
         (MaxOpenOrders > TotalChartOrders()) &&
         !Order2Open)
      {
         //OpenSingleBuy(2,"b2");
         if(UseStops)
            OpenSingleSell(1,"s1");
         return;
      }
      
      if((_bid > open) && 
         (bar1size > Level1Pips) && 
         (MaxOpenOrders > TotalChartOrders()) &&
         !Order1Open)
      {
         //OpenSingleBuy(1,"b1");
         if(UseStops)
            OpenSingleSell(1,"s1");
         return;
      }
      
      //sell
      if((_ask < open) && (bar1size > Level4Pips) && (MaxOpenOrders > TotalChartOrders()))
      {
         //OpenSingleSell(4,"b4");
         if(UseStops)
           OpenSingleBuy(4,"s4");
         return;
      }
      if((_ask < open) && (bar1size > Level3Pips) && (MaxOpenOrders > TotalChartOrders()))
      {
         //OpenSingleSell(3,"b3");
         if(UseStops)
           OpenSingleBuy(3,"s3");
         return;
      }
      if((_ask < open) && (bar1size > Level2Pips) && (MaxOpenOrders > TotalChartOrders()))
      {
         //OpenSingleSell(2,"b2");
         if(UseStops)
           OpenSingleBuy(2,"s2");
         return;
      }                  
      if((_ask < open) && (bar1size > Level1Pips) && (MaxOpenOrders > TotalChartOrders()))
      {
         //OpenSingleSell(1,"b1");
         if(UseStops)
           OpenSingleBuy(1,"s1");
         return;
      }
   }
   if (StringFind(Symbol(), "EURUSD") == -1) 
      ObjectSetText("lblTop", msg, 10, "Arial", Black);
   else 
      ObjectSetText("lblTop", "", 10, "Arial", White);
   return;
}

///////////////////////////////////////////////////////////////////////////////
//
//
void UpdateStats()
{
   double loss=0;
   if(value_profit() < 0)
      loss = (-1 * value_profit() * 100) / AccountBalance();
   string  txt3 = (DoubleToStr(loss, 2));

   double profit = 0;
   if(value_profit() > 0)
      profit = (1 * value_profit() * 100) / AccountBalance();
   string  txt2=(DoubleToStr(profit,2));
   SetLabel("Label0","   Trading information",TextColor,5,26);
   SetLabel("Label1","   ",TextColor,5,32);
   SetLabel("Label2","   ",TextColor,5,130);
   SetLabel("Label3","   Drawdown: ",TextColor,5,46);
   SetLabel("Label4","   Profit: ",TextColor,5,59);
   SetLabel("Label5","   Today: ",TextColor,5,72);
   SetLabel("Label6","   Yesterday: ",TextColor,5,85);
   SetLabel("Label7","   Current month: ",TextColor,5,98);
   SetLabel("Label8","   Previous month: ",TextColor,5,111);
   SetLabel("Label9","   Total profit: ",TextColor,5,124);
   SetLabel("Label11",txt3,TextColor,125,46);
   SetLabel("Label12",txt2,TextColor,125,59);
   SetLabel("Label13",DoubleToStr(Profit(0),2),TextColor,125,72);
   SetLabel("Label14",DoubleToStr(Profit(1),2),TextColor,125,85);
   SetLabel("Label15",DoubleToStr(ProfitMons(0),2),TextColor,125,98);
   SetLabel("Label16",DoubleToStr(ProfitMons(1),2),TextColor,125,111);
   SetLabel("Label17",DoubleToStr(TotalProfit(),2),TextColor,125,124);
   SetLabel("Label19","%",TextColor,195,46);
   SetLabel("Label20","%",TextColor,195,59);
   SetLabel("Label21",AccountCurrency(),TextColor,195,72);
   SetLabel("Label22",AccountCurrency(),TextColor,195,85);
   SetLabel("Label23",AccountCurrency(),TextColor,195,98);
   SetLabel("Label24",AccountCurrency(),TextColor,195,111);
   SetLabel("Label25",AccountCurrency(),TextColor,195,124);
   SetLabel("Label26","   Total CF profit: ",TextColor,5,144);
   SetLabel("Label27",DoubleToStr(TotalCFProfit(),2),TextColor,125,144);
   SetLabel("Label28",AccountCurrency(),TextColor,195,144);
   for (int i = 0; i < 29; i++)
   {
      ObjectSetInteger(0,"Label" + IntegerToString(i,0,' ') ,OBJPROP_ZORDER,0);
   }
}

///////////////////////////////////////////////////////////////////////////////
//
//
//
void SetLabel(string nm,string tx,color cl,int xd,int yd,int cr=0,int fs=9,string font="Tahoma",bool bAlignLeft = false)
{
   if(ObjectFind(nm)<0) ObjectCreate(nm,OBJ_LABEL,0,0,0);
   ObjectSetText(nm,tx,fs,font,cl);
   ObjectSet(nm,OBJPROP_COLOR,cl);
   ObjectSet(nm,OBJPROP_XDISTANCE,xd);
   ObjectSet(nm,OBJPROP_YDISTANCE,yd);
   ObjectSet(nm,OBJPROP_CORNER,cr);
   ObjectSet(nm,OBJPROP_FONTSIZE,fs);
   ObjectSet(nm,OBJPROP_BACK,false);
   ObjectSet(nm,OBJPROP_SELECTABLE,false);
   ObjectSet(nm,OBJPROP_READONLY,false);
   ObjectSet(nm,OBJPROP_ALIGN,2);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double TotalProfit()
{
   {
      double OProfit = 0;
      for(int i = 0; i < OrdersHistoryTotal(); i++)
      {
         if(!(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY))) 
            break;
         if(OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
            if(OrderCloseTime() >= iTime(Symbol(),PERIOD_MN1,1200))
               OProfit += OrderProfit();
      }
      return (OProfit);
   }
}
//+------------------------------------------------------------------+
//| Profit from all charts using Coin Flip                                                                  |
//+------------------------------------------------------------------+
double TotalCFProfit()
{
   {
      double OProfit=0;
      for(int i=0; i<OrdersHistoryTotal(); i++)
      {
         if(!(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY))) 
            break;
         if(OrderMagicNumber() == MagicNumber)
            if(OrderCloseTime() >= iTime(Symbol(),PERIOD_MN1,1200))
               OProfit += OrderProfit();
      }
      return (OProfit);
   }
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double Profit(int Bar)
  {
   double OProfit=0;
   for(int i=0; i<OrdersHistoryTotal(); i++)
     {
      if(!(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY))) break;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
         if(OrderCloseTime() >= iTime(Symbol(),PERIOD_D1,Bar) 
            && OrderCloseTime() < iTime(Symbol(),PERIOD_D1,Bar) + 86400) 
            OProfit+=OrderProfit();
     }
   return (OProfit);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double ProfitMons(int Bar)
  {
   double OProfit=0;
   for(int i=0; i<OrdersHistoryTotal(); i++)
     {
      if(!(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY))) break;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
         if(OrderCloseTime()>=iTime(Symbol(),PERIOD_MN1,Bar) && OrderCloseTime()<iTime(Symbol(),PERIOD_MN1,Bar)+2592000) OProfit+=OrderProfit();
     }
   return (OProfit);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double value_profit()
  {
   double ID=0;
   int OT=OrdersTotal();
   if(OT>0)
     {
      for(int i=OT-1; i>=0; i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
           {
            if(OrderMagicNumber()==MagicNumber && OrderSymbol()==Symbol())
               ID+=OrderProfit()+OrderSwap()+OrderCommission();
           }
        }
     }
   return(ID);
  }
///////////////////////////////////////////////////////////////////////////////
//
//
string Error(int error_code)
  {
   string error_string;
   switch(error_code)
     {
      case 0:
         error_string="no error returned.";                                                                  break;
      case 1:
         error_string="no error returned, but the result is unknown.";                                       break;
      case 2:
         error_string="common error.";                                                                       break;
      case 3:
         error_string="invalid trade parameters.";                                                           break;
      case 4:
         error_string="trade server is busy.";                                                               break;
      case 5:
         error_string="old version of the client terminal.";                                                 break;
      case 6:
         error_string="no connection with trade server.";                                                    break;
      case 7:
         error_string="not enough rights.";                                                                  break;
      case 8:
         error_string="too frequent requests.";                                                              break;
      case 9:
         error_string="malfunctional trade operation.";                                                      break;
      case 64:
         error_string="account disabled.";                                                                   break;
      case 65:
         error_string="invalid account.";                                                                    break;
      case 128:
         error_string="trade timeout.";                                                                      break;
      case 129:
         error_string="invalid price.";                                                                      break;
      case 130:
         error_string="invalid stops.";                                                                      break;
      case 131:
         error_string="invalid trade volume.";                                                               break;
      case 132:
         error_string="market is closed.";                                                                   break;
      case 133:
         error_string="trade is disabled.";                                                                  break;
      case 134:
         error_string="not enough money.";                                                                   break;
      case 135:
         error_string="price changed.";                                                                      break;
      case 136:
         error_string="off quotes.";                                                                         break;
      case 137:
         error_string="broker is busy.";                                                                     break;
      case 138:
         error_string="requote.";                                                                            break;
      case 139:
         error_string="order is locked.";                                                                    break;
      case 140:
         error_string="long positions only allowed.";                                                        break;
      case 141:
         error_string="too many requests.";                                                                  break;
      case 145:
         error_string="modification denied because an order is too close to market.";                        break;
      case 146:
         error_string="trade context is busy.";                                                              break;
      case 147:
         error_string="expirations are denied by broker.";                                                   break;
      case 148:
         error_string="the amount of opened and pending orders has reached the limit set by a broker.";      break;
      case 4000:
         error_string="no error.";                                                                           break;
      case 4001:
         error_string="wrong function pointer.";                                                             break;
      case 4002:
         error_string="array index is out of range.";                                                        break;
      case 4003:
         error_string="no memory for function call stack.";                                                  break;
      case 4004:
         error_string="recursive stack overflow.";                                                           break;
      case 4005:
         error_string="not enough stack for parameter.";                                                     break;
      case 4006:
         error_string="no memory for parameter string.";                                                     break;
      case 4007:
         error_string="no memory for temp string.";                                                          break;
      case 4008:
         error_string="not initialized string.";                                                             break;
      case 4009:
         error_string="not initialized string in an array.";                                                 break;
      case 4010:
         error_string="no memory for an array string.";                                                      break;
      case 4011:
         error_string="too long string.";                                                                    break;
      case 4012:
         error_string="remainder from zero divide.";                                                         break;
      case 4013:
         error_string="zero divide.";                                                                        break;
      case 4014:
         error_string="unknown command.";                                                                    break;
      case 4015:
         error_string="wrong jump.";                                                                         break;
      case 4016:
         error_string="not initialized array.";                                                              break;
      case 4017:
         error_string="DLL calls are not allowed.";                                                          break;
      case 4018:
         error_string="cannot load library.";                                                                break;
      case 4019:
         error_string="cannot call function.";                                                               break;
      case 4020:
         error_string="EA function calls are not allowed.";                                                  break;
      case 4021:
         error_string="not enough memory for a string returned from a function.";                            break;
      case 4022:
         error_string="system is busy.";                                                                     break;
      case 4050:
         error_string="invalid function parameters count.";                                                  break;
      case 4051:
         error_string="invalid function parameter value.";                                                   break;
      case 4052:
         error_string="string function internal error.";                                                     break;
      case 4053:
         error_string="some array error.";                                                                   break;
      case 4054:
         error_string="incorrect series array using.";                                                       break;
      case 4055:
         error_string="custom indicator error.";                                                             break;
      case 4056:
         error_string="arrays are incompatible.";                                                            break;
      case 4057:
         error_string="global variables processing error.";                                                  break;
      case 4058:
         error_string="global variable not found.";                                                          break;
      case 4059:
         error_string="function is not allowed in testing mode.";                                            break;
      case 4060:
         error_string="function is not confirmed.";                                                          break;
      case 4061:
         error_string="mail sending error.";                                                                 break;
      case 4062:
         error_string="string parameter expected.";                                                          break;
      case 4063:
         error_string="integer parameter expected.";                                                         break;
      case 4064:
         error_string="double parameter expected.";                                                          break;
      case 4065:
         error_string="array as parameter expected.";                                                        break;
      case 4066:
         error_string="requested history data in updating state.";                                           break;
      case 4067:
         error_string="some error in trade operation execution.";                                            break;
      case 4099:
         error_string="end of a file.";                                                                      break;
      case 4100:
         error_string="some file error.";                                                                    break;
      case 4101:
         error_string="wrong file name.";                                                                    break;
      case 4102:
         error_string="too many opened files.";                                                              break;
      case 4103:
         error_string="cannot open file.";                                                                   break;
      case 4104:
         error_string="incompatible access to a file.";                                                      break;
      case 4105:
         error_string="no order selected.";                                                                  break;
      case 4106:
         error_string="unknown symbol.";                                                                     break;
      case 4107:
         error_string="invalid price param.";                                                                break;
      case 4108:
         error_string="invalid ticket.";                                                                     break;
      case 4109:
         error_string="trade is not allowed.";                                                               break;
      case 4110:
         error_string="longs are not allowed.";                                                              break;
      case 4111:
         error_string="shorts are not allowed.";                                                             break;
      case 4200:
         error_string="object already exists.";                                                              break;
      case 4201:
         error_string="unknown object property.";                                                            break;
      case 4202:
         error_string="object does not exist.";                                                              break;
      case 4203:
         error_string="unknown object type.";                                                                break;
      case 4204:
         error_string="no object name.";                                                                     break;
      case 4205:
         error_string="object coordinates error.";                                                           break;
      case 4206:
         error_string="no specified subwindow.";                                                             break;
      case 4207:
         error_string="ERR_SOME_OBJECT_ERROR.";                                                              break;
      default:
         error_string="error is not known.";
     }
   return(error_string);
  }
